#include "COMMON.H"

extern HANDLE	SOFT_hModule;
SOFT_CONFIG		SOFT_Config;
int				SOFT_nReturn = 0;

SOFT_CONFIG Default =
{
	0,
	BST_UNCHECKED,
	BST_UNCHECKED
};

char *strResolutions[] =
{
	"320x240",
	"640x480",
	"800x600",
	"1024x768",
	NULL
};

void CONFIG_LoadConfiguration()
{
	DWORD dwDisp;
	DWORD dwSize = sizeof(SOFT_CONFIG);
	HKEY hkey;
	RegCreateKeyEx(HKEY_LOCAL_MACHINE, "Software\\Virtual Applications\\xBUILD Software Renderer", NULL, NULL, NULL, KEY_ALL_ACCESS, NULL, &hkey, &dwDisp);
	if(dwDisp & REG_CREATED_NEW_KEY)
	{
		memmove(&SOFT_Config, &Default, sizeof(SOFT_CONFIG));
		RegCloseKey(hkey);
		RegDeleteKey(HKEY_LOCAL_MACHINE, "Software\\Virtual Applications\\xBUILD Software Renderer");
		return;
	}
	RegQueryValueEx(hkey, "Config", NULL, NULL, (unsigned char*)&SOFT_Config, &dwSize);
	RegCloseKey(hkey);
}

void CONFIG_SaveConfiguration()
{
	HKEY hkey;
	DWORD dwSize = sizeof(SOFT_CONFIG);
	RegCreateKeyEx(HKEY_LOCAL_MACHINE, "Software\\Virtual Applications\\xBUILD Software Renderer", NULL, NULL, NULL, KEY_ALL_ACCESS, NULL, &hkey, NULL);
	RegSetValueEx(hkey, "Config", NULL, NULL, (unsigned char*)&SOFT_Config, dwSize);
	RegCloseKey(hkey);
}

int WINAPI CfgProc(HWND hWnd, unsigned int uiMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uiMsg)
	{
	case WM_COMMAND:
		switch(wParam)
		{
		case 2:
			DestroyWindow(hWnd);
			break;
		case IDOK:
			SOFT_nReturn = 1;
			DestroyWindow(hWnd);
			break;
		case IDC_2XSAI:
			int nCheck;
			nCheck = SendDlgItemMessage(hWnd, IDC_2XSAI, BM_GETCHECK, 0, 0);
			if(nCheck == BST_CHECKED)
			{
				EnableWindow(GetDlgItem(hWnd, IDC_RES), FALSE);
				EnableWindow(GetDlgItem(hWnd, IDC_FULLSCREEN), FALSE);
				SendDlgItemMessage(hWnd, IDC_FULLSCREEN, BM_SETCHECK, BST_CHECKED, 0);
				SendDlgItemMessage(hWnd, IDC_RES, CB_SETCURSEL, 1, 0);
			}
			else
			{
				EnableWindow(GetDlgItem(hWnd, IDC_RES), TRUE);
				EnableWindow(GetDlgItem(hWnd, IDC_FULLSCREEN), TRUE);
			}
			break;
		}
		break;
	case WM_DESTROY:
		SOFT_Config.nVideoMode		= SendDlgItemMessage(hWnd, IDC_RES, CB_GETCURSEL, 0, 0);
		SOFT_Config.nFullscreen		= SendDlgItemMessage(hWnd, IDC_FULLSCREEN, BM_GETCHECK, 0, 0);
		SOFT_Config.n2xSaI			= SendDlgItemMessage(hWnd, IDC_2XSAI, BM_GETCHECK, 0, 0);
		break;
	case WM_INITDIALOG:
		int i;
		i = 0;
		while(1)
		{
			SendDlgItemMessage(hWnd, IDC_RES, CB_ADDSTRING, NULL, (LPARAM)strResolutions[i]);
			i++;
			if(strResolutions[i] == NULL)
			{
				break;
			}
		}
		SendDlgItemMessage(hWnd, IDC_RES, CB_SETCURSEL, SOFT_Config.nVideoMode, 0);
		SendDlgItemMessage(hWnd, IDC_FULLSCREEN, BM_SETCHECK, SOFT_Config.nFullscreen, 0);
		SendDlgItemMessage(hWnd, IDC_2XSAI, BM_SETCHECK, SOFT_Config.n2xSaI, 0);
		SendMessage(hWnd, WM_COMMAND, IDC_2XSAI, 0);
		break;
	}
	return FALSE;
}

void CONFIG_Start()
{
	CONFIG_LoadConfiguration();
	DialogBox((HINSTANCE)SOFT_hModule, MAKEINTRESOURCE(IDD_CONFIG), NULL, CfgProc);
	if(SOFT_nReturn)
	{
		CONFIG_SaveConfiguration();
	}
}