// Movie.h: interface for the CMovie class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MOVIE_H__85D24AC1_C302_11D5_9FD0_0048548C5440__INCLUDED_)
#define AFX_MOVIE_H__85D24AC1_C302_11D5_9FD0_0048548C5440__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

struct COLORCYCLE
{
	unsigned _int16		Count;
	unsigned _int16		Rate;
	unsigned _int16		Flags;
	unsigned _int8		Low;
	unsigned _int8		High;
};

struct ANMHEADER
{
	char				LPF[4];
	unsigned _int16		maxLPS;
	unsigned _int16		LPS;
	unsigned _int32		RecordNumber;
	unsigned _int16		RecordPerLPS;
	unsigned _int16		SeekOffset;
	char				ANIM[4];
	unsigned _int16		Width;
	unsigned _int16		Height;
	unsigned _int8		Variant;
	unsigned _int8		Version;
	unsigned _int8		Loop;
	unsigned _int8		LoopValid;
	unsigned _int8		PixelType;
	unsigned _int8		CompressionType;
	unsigned _int8		RecordsPerFrame;
	unsigned _int8		BitmapType;
	unsigned _int8		RecordType[32];
	unsigned _int32		Frames;
	unsigned _int16		FramesPerSecond;
	unsigned _int16		Pad[29];
	COLORCYCLE			Cycle[16];
};

struct ANMPALETTE
{
	unsigned _int8		B;
	unsigned _int8		G;
	unsigned _int8		R;
	unsigned _int8		U;
};

struct LPHEADER
{
	unsigned _int16 BaseRecord;
	unsigned _int16 Records;
	unsigned _int16 Size;
};

class CMovie  
{
public:
	CMovie();
	virtual				~CMovie();
	void				PlayANM(char*);
	ANMHEADER			header;
	ANMPALETTE			palette[256];
	LPHEADER			tmpLP[256];
	unsigned _int32*	LPOffset;
	unsigned _int32*	pRendererBuffer;
	unsigned _int8*		pFrameBuffer;
	char				strFile[32];
	int					nFrameNum;
	FILE*				pStream;
	HANDLE				hThread;
	DWORD				dwTID;
	int					nFinished;
};

#endif // !defined(AFX_MOVIE_H__85D24AC1_C302_11D5_9FD0_0048548C5440__INCLUDED_)
