#include <STDAFX.H>
#include <DIRECT.H>
#include "RENDERER.H"

void (*GetRendererContextDLL)(XBUILDRENCONTEXT*);

int RENDERER::GetAvaliableRenderers(RENDERERINFO *info, int number)
{
	HANDLE next;
	WIN32_FIND_DATA res;
	XBUILDRENCONTEXT context;
	char strPath[256];
	int found = 0;
	getcwd(strPath, 256);
	strcat(strPath, "\\REND*.DLL");
	memset(info, 0, sizeof(RENDERERINFO));
	next = FindFirstFile(strPath, &res);
	if(next == INVALID_HANDLE_VALUE)
	{
		CString str;
		str.Format("Couldn't find any renderers in the '%s' directory.", strPath);
		MessageBox(NULL, str, "glDuke", 16);
		return 2;
	}
	while(1)
	{
		if(found == number)
		{
			strcpy(info->Filename, res.cFileName);
			GetRendererContext(res.cFileName, &context, NULL);
			memmove(info->Author, context.Author, 256);
			memmove(info->Description, context.Description, 256);
			memmove(info->Version, context.Version, 256);
			break;
		}
		found++;
		if(!FindNextFile(next, &res))
		{
			FindClose(next);
			return 0;
			break;
		}
	}
	FindClose(next);
	return 1;
}

int RENDERER::GetRendererContext(char *lpstrFile, XBUILDRENCONTEXT *context, HMODULE *hModule)
{
	char strPath[_MAX_PATH];
	HMODULE hMod;
	XBUILDRENCONTEXT con;
	getcwd(strPath, _MAX_PATH);
	strcat(strPath, "\\");
	strcat(strPath, lpstrFile);
	hMod = LoadLibrary(strPath);
	if(hMod == NULL)
	{
		MessageBox(NULL, "Couldn't load the renderer.", lpstrFile, 16);
		return 0;
	}
	GetRendererContextDLL = (void (*)(XBUILDRENCONTEXT*))GetProcAddress(hMod, "GetRendererContext");
	if(GetRendererContextDLL == NULL)
	{
		return 0;
	}
	GetRendererContextDLL(&con);
	memmove(context, &con, sizeof(XBUILDRENCONTEXT));
	if(hModule != NULL)
	{
		*hModule = hMod;
	}
	else
	{
		FreeLibrary(hMod);
	}
	return 1;
}
