// glDukeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "glDuke.h"
#include "glDukeDlg.h"
#include "RendererOpt.h"
#include "About.h"
#include "Keyboard.h"
#include "Controls.h"
#include "MouseOpt.h"
#include "CustomLvl.h"
#include "MusicOpt.h"
#include "Joystick.h"
#include "ModTC.h"
#include "GenSoundOpt.h"
#include "Settings.h"

extern CSettings set;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

TItem *hCurrent;
#define OPTIONSCNT 10

TItem Options[] = 
{
	{ 1, "Renderer Settings",		IDD_RENDERER,	NULL, NULL, NULL, FALSE, 0 }, 
	{ 2, "About",					IDD_ABOUT,		NULL, NULL, NULL, FALSE, 0 },
	{ 3, "Controls Settings",		IDD_CONTROLS,	NULL, NULL, NULL, FALSE, 0 },
	{ 4, "Keyboard Settings",		IDD_KEYBOARD,	NULL, NULL, NULL, FALSE, 0 },
	{ 5, "Mouse Settings",			IDD_MOUSE,		NULL, NULL, NULL, FALSE, 0 },
	{ 6, "User Level Selection",	IDD_CUSTOMLVL,	NULL, NULL, FALSE, 0 },
	{ 7, "Sound Settings",			IDD_SOUND,		NULL, NULL, FALSE, 0 },
	{ 8, "Music Settings",			IDD_MUSIC,		NULL, NULL, FALSE, 0 },
	{ 9, "Mods/TCs",				IDD_MODTC,		NULL, NULL, FALSE, 0 },
	{ 10,"Joystick Settings",		IDD_JOYSTICK,	NULL, NULL, FALSE, 0 },
	NULL,
};

/////////////////////////////////////////////////////////////////////////////
// CGlDukeDlg dialog

CGlDukeDlg::CGlDukeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGlDukeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGlDukeDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGlDukeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGlDukeDlg)
	DDX_Control(pDX, IDC_TREE, m_Tree);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGlDukeDlg, CDialog)
	//{{AFX_MSG_MAP(CGlDukeDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE, OnSelchangedTree)
	ON_BN_CLICKED(ID_CLOSE, OnClose)
	ON_BN_CLICKED(IDC_QUIT, OnQuit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGlDukeDlg message handlers

CDialog *CGlDukeDlg::GetCorrectClass(int nOpt)
{
	CDialog *dlg;
	switch(nOpt)
	{
	case 1:
		dlg = new CRendererOpt;
		break;
	case 2:
		dlg = new CAbout;
		break;
	case 3:
		dlg = new CControls;
		break;
	case 4:
		dlg = new CKeyboard;
		break;
	case 5:
		dlg = new CMouseOpt;
		break;
	case 6:
		dlg = new CCustomLvl;
		break;
	case 7:
		dlg = new CGenSoundOpt;
		break;
	case 8:
		dlg = new CMusicOpt;
		break;
	case 9:
		dlg = new CModTC;
		break;
	case 10:
		dlg = new CJoystick;
		break;
	default:
		dlg = new CDialog;
		break;
	}
	return dlg;
}

void CGlDukeDlg::InsertItem(HTREEITEM hParent, TItem *item, BOOL bSelected)
{
	HTREEITEM hItem;
	CDialog *dlg;
	CRect rc;
	hItem = m_Tree.InsertItem(item->strName, hParent);
	item->Handle = (void*)hItem;
	item->Parent = (void*)hParent;
	m_Tree.SetItemData(hItem, (DWORD)item);
	dlg = GetCorrectClass(item->nID);
	dlg->Create(item->nDialog, this);
	GetDlgItem(IDC_PLACEHOLDER)->GetWindowRect(&rc);
	ScreenToClient(&rc);
	dlg->SetWindowPos(NULL, rc.left, rc.top, 0, 0, SWP_NOZORDER | SWP_NOSIZE | SWP_NOACTIVATE);
	dlg->EnableWindow(TRUE);
	item->dialog = dlg;
	item->Created = TRUE;
	m_Tree.Expand(hParent, TVE_EXPAND);
}

BOOL CGlDukeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	nCanceled = 0;
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	InsertItem(NULL, &Options[0], TRUE);
	InsertItem(NULL, &Options[2], TRUE);
	InsertItem((HTREEITEM)Options[2].Handle, &Options[3], TRUE);
	InsertItem((HTREEITEM)Options[2].Handle, &Options[4], TRUE);
	InsertItem((HTREEITEM)Options[2].Handle, &Options[9], TRUE);
	InsertItem(NULL, &Options[6], TRUE);
	InsertItem((HTREEITEM)Options[6].Handle, &Options[7], TRUE);
	InsertItem(NULL, &Options[5], TRUE);
	InsertItem(NULL, &Options[8], TRUE);
	InsertItem(NULL, &Options[1], TRUE);
	m_Tree.SelectItem((HTREEITEM)Options[1].Handle);
	m_Tree.SetFocus();
	//return TRUE;  // return TRUE  unless you set the focus to a control
	return FALSE;
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGlDukeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGlDukeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CGlDukeDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	int i = 0;
	// TODO: Add your message handler code here
	while(i < OPTIONSCNT)
	{
		if(Options[i].Created)
		{
			Options[i].dialog->SendMessage(WM_DESTROY);
			delete Options[i].dialog;
		}
		i++;
	}
}

void CGlDukeDlg::OnSelchangedTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	HTREEITEM hItem;
	TItem *itm;
	hItem = m_Tree.GetSelectedItem();
	itm = (TItem*)m_Tree.GetItemData(hItem);
	if(itm != hCurrent)
	{
		if(hCurrent != NULL)
		{
			hCurrent->dialog->ShowWindow(SW_HIDE);
		}
		itm->dialog->ShowWindow(SW_SHOW);
		itm->dialog->InvalidateRect(NULL);
		itm->dialog->UpdateWindow();
		hCurrent = itm;
	}
	GetDlgItem(IDC_PLACEHOLDER)->UpdateWindow();
	GetDlgItem(IDC_PLACEHOLDER)->SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
	*pResult = 0;
}

void CGlDukeDlg::OnClose() 
{
	// TODO: Add your control notification handler code here
	nCanceled = 1;
	set.Save();
	SendMessage(WM_COMMAND, 2, 0);
}

void CGlDukeDlg::OnQuit() 
{
	// TODO: Add your control notification handler code here
	SendMessage(WM_COMMAND, 2, 0);	
}
