#ifndef _CONSCRIPT_H_
#define _CONSCRIPT_H_

#define MAXSTATE	0xBE
#define MAXACTOR	0xF0

struct BLK_DEFINE
{
	char strSymbol[64];
	int nValue;
};

struct BLK_DEFINEQUOTE
{
	int nNumber;
	char strQuote[64];
};

struct BLK_DEFINESOUND
{
	int		nNumber;
	char	strFilename[32];
	int		nPitchVariation1;
	int		nPitchVariation2;
	int		nPriority;
	int		nStatus;
	int		nVolumeAdjust;
};

struct BLK_DEFINEVOLUMENAME
{
	int		nNumber;
	char	strName[32];
};

struct BLK_DEFINESKILLNAME
{
	int		nNumber;
	char	strName[32];
};

struct BLK_DEFINELEVELNAME
{
	int		nEpisode;
	int		nLevel;
	char	strFilename[32];
	char	strPar[10];
	char	str3DRealmsPar[10];
	char	strLevelname[32];
};

struct BLK_MUSIC
{
	int		nEpisode;
	char	strFilename01[32];
	char	strFilename02[32];
	char	strFilename03[32];
	char	strFilename04[32];
	char	strFilename05[32];
	char	strFilename06[32];
	char	strFilename07[32];
	char	strFilename08[32];
	char	strFilename09[32];
	char	strFilename10[32];
	char	strFilename11[32];
};

struct BLK_GAMESTARTUP
{
	int		nVisibility;
	int		nImpactDamage;
	int		nMaxPlayerHealth;
	int		nArmorHealth;
	int		nActorRespawnTime;
	int		nItemRespawnTime;
	int		nRunningSpeed;
	int		nGravitationnalConstant;
	int		nRPGBlastRadius;
	int		nPipebombBlastRadius;
	int		nShrinkerBlastRadius;
	int		nTripbombBlastRadius;
	int		nMorterBlastRadius;
	int		nBounceMineBlastRadius;
	int		nSeenineBlastRadius;
	int		nMaxPistolAmmo;
	int		nMaxShotgunAmmo;
	int		nMaxChaingunAmmo;
	int		nMaxRPGAmmo;
	int		nMaxPipebombAmmo;
	int		nMaxShrinkerAmmo;
	int		nMaxDevastatorAmmo;
	int		nMaxTripbombAmmo;
	int		nMaxFreezeAmmo;
	int		nMaxGrowAmmo;
	int		nCameraDestructible;
	int		nNumberFreezeBounces;
	int		nFreezerHurtsOwner;
	int		nQSize;
	int		nTripbombLaserMode;
};

struct BLK_ACTOR
{
	int		nSprite;
	int		nHealth;
	char	strCode[0x3000];
};

struct BLK_STATE
{
	char	strName[256];
	char	strCode[0x3000];
};

struct XBUILD_CONSCRIPT_CONTEXT
{
	BLK_DEFINE				Define[0x600];
	BLK_DEFINEQUOTE			DefineQuote[0x80];
	BLK_DEFINESOUND			DefineSound[400];
	BLK_DEFINEVOLUMENAME	DefineVolumename[10];
	BLK_DEFINELEVELNAME		DefineLevelname[50];
	BLK_DEFINESKILLNAME		DefineSkillname[10];
	BLK_MUSIC				Music[5];
	BLK_GAMESTARTUP			Gamestartup;
	BLK_ACTOR				Actor[MAXACTOR];
	BLK_STATE				State[MAXSTATE];
	int						nDefineCount;
	int						nDefineQuoteCount;
	int						nDefineSoundCount;
	int						nDefineVolumenameCount;
	int						nDefineLevelnameCount;
	int						nDefineSkillnameCount;
	int						nMusicCount;
	int						nActorCount;
	int						nStateCount;
	int						nGamestartupCount;
};

#endif
