#ifndef _MAP_H_
#define _MAP_H_

struct XBUILD_MAP_MAPINFO
{
	unsigned	_int32	Version;
	signed		_int32	StartX;
	signed		_int32	StartY;
	signed		_int32	StartZ;
	unsigned	_int16	StartA;
	unsigned	_int16	FirstSector;
	unsigned	_int16	SectorNumber;
	unsigned	_int16	WallNumber;
	unsigned	_int16	SpriteNumber;
};

struct XBUILD_MAP_SECTOR
{
	unsigned	_int16	WallPointer;
	unsigned	_int16	WallNumber;
	signed		_int32	CZ;					//Ceiling Z position
	signed		_int32	FZ;					//Floor Z position
	unsigned	_int16	CStat;				//Ceiling Status
	unsigned	_int16	FStat;				//Floor Status
	unsigned	_int16	CPic;				//Ceiling Picture Number
	unsigned	_int16	CHei;				//Ceiling Slope
	signed		_int8	CShade;				//Ceiling Shade
	unsigned	_int8	CPal;				//Ceiling Palette
	unsigned	_int8	CPanX;				//Ceiling Texture Pan X
	unsigned	_int8	CPanY;				//Ceiling Texture Pan Y
	unsigned	_int16	FPic;				//Floor Picture Number
	unsigned	_int16	FHei;				//Floor Slope
	signed		_int8	FShade;				//Floor Shade
	unsigned	_int8	FPal;
	unsigned	_int8	FPanX;
	unsigned	_int8	FPanY;
	unsigned	_int8	Visibility;
	unsigned	_int8	Filler;
	unsigned	_int16	LoTag;
	unsigned	_int16	HiTag;
	unsigned	_int16	Extra;
};

struct XBUILD_MAP_WALL
{
	signed		_int32	X;
	signed		_int32	Y;
	unsigned	_int16	Point2;
	signed		_int16	NextWall;
	signed		_int16	NextSector;
	unsigned	_int16	CStat;
	unsigned	_int16	Pic;
	unsigned	_int16	OverPic;
	signed		_int8	Shade;
	unsigned	_int8	Pal;
	unsigned	_int8	RepX;
	unsigned	_int8	RepY;
	unsigned	_int8	PanX;
	unsigned	_int8	PanY;
	unsigned	_int16	LoTag;
	unsigned	_int16	HiTag;
	unsigned	_int16	Extra;
};

struct XBUILD_MAP_SPRITE
{
	signed		_int32	X;
	signed		_int32	Y;
	signed		_int32	Z;
	unsigned	_int16	CStat;
	unsigned	_int16	Pic;
	signed		_int8	Shade;
	unsigned	_int8	Palette;
	unsigned	_int8	Clipdist;
	unsigned	_int8	Filler;
	unsigned	_int8	RepX;
	unsigned	_int8	RepY;
	signed		_int8	OffX;
	signed		_int8	OffY;
	unsigned	_int16	SectorNum;
	unsigned	_int16	StatNum;
	unsigned	_int16	Angle;
	unsigned	_int16	Owner;
	unsigned	_int16	VelX;
	unsigned	_int16	VelY;
	unsigned	_int16	VelZ;
	unsigned	_int16	LoTag;
	unsigned	_int16	HiTag;
	unsigned	_int16	Extra;
};

struct XBUILD_MAP
{
	XBUILD_MAP_MAPINFO	Mapinfo;
	XBUILD_MAP_SECTOR	Sector[MAXSECTORS];
	XBUILD_MAP_WALL		Wall[MAXWALLS];
	XBUILD_MAP_SPRITE	Sprite[MAXSPRITES];
};

#define MAP XBUILD_MAP
#define MAPINFO XBUILD_MAP_MAPINFO
#define SECTOR XBUILD_MAP_SECTOR
#define WALL XBUILD_MAP_WALL
#define SPRITE XBUILD_MAP_SPRITE

#endif